{-# LANGUAGE CPP #-}
import qualified Data.Trie as S
import qualified Data.Foldable as F
#include "../benchs/Hash.mod.inc.hs"

bEmpty = S.empty
bSingleton x = S.singleton x ()
bInsert s x = S.insert x () s
bDelete s x = S.delete x s
bMember s x = S.member x s
bUnion m n = S.unionL m n
bToList s = S.toList s
bForce s = F.foldr (seq . rnf) () s

#define BENCH_BSTR_ONLY

#include "../benchs/Hash.inc.hs"
