{-# LANGUAGE CPP #-}
module Main where

import qualified Data.HashSet as S
#include "../benchs/Hash.mod.inc.hs"

bEmpty = S.empty
bSingleton x = S.singleton x
bInsert s x = S.insert x s
bDelete s x = S.delete x s
bMember s x = S.member x s
bUnion m n = S.union m n
bToList s = S.toList s
bForce s = S.fold (seq . rnf) () s

#include "../benchs/Hash.inc.hs"
