{-# LANGUAGE CPP #-}
#include "../benchs/Queue.mod.inc.hs"

data Queue a = Queue {-# UNPACK #-} !Int [a] {-# UNPACK #-} !Int [a]

check q@(Queue lenh h lent t)
  | lenh < lent = Queue (lenh + lent) (h ++ reverse t) 0 []
  | otherwise   = q

qPush x (Queue lenh h lent t) = check $ Queue lenh h (lent+1) (x:t)
qPop (Queue 0 _ _ _) = undefined
qPop (Queue lenh (x:h) lent t) = check $ Queue (lenh-1) h lent t
qEmpty = Queue 0 [] 0 []
qNull (Queue len _ _ _) = len == 0

#include "../benchs/Queue.inc.hs"
