{-# LANGUAGE CPP #-}
#include "../benchs/Queue.mod.inc.hs"

data Queue a = Queue [a] [a]

check q@(Queue [] []) = q
check (Queue [] t) = Queue (reverse t) []
check q = q

qPush x (Queue h t) = check $ Queue h (x:t)
qPop (Queue [] _) = undefined
qPop (Queue (x:h) t) = check $ Queue h t
qEmpty = Queue [] []
qNull (Queue h _) = null h

#include "../benchs/Queue.inc.hs"
