{-# LANGUAGE CPP #-}
#include "../benchs/Queue.mod.inc.hs"

data Queue a = Queue [a] [a] [a]

check (Queue h t []) = case rotate h t [] of h' -> Queue h' [] h'
check (Queue h t (_:s)) = Queue h t s

rotate [] [y] acc = y : acc
rotate (x:xs) (y:ys) acc = x : rotate xs ys (y:acc)

qPush x (Queue h t s) = check $ Queue h (x:t) s
qPop (Queue [] _ _) = undefined
qPop (Queue (x:h) t s) = check $ Queue h t s
qEmpty = Queue [] [] []
qNull (Queue h _ _) = null h

#include "../benchs/Queue.inc.hs"
