{-# LANGUAGE CPP #-}
import qualified Data.Array.IO as A
import System.IO.Unsafe (unsafePerformIO)
#include "../benchs/Ral.mod.inc.hs"

ralFromList :: [a] -> A.IOArray Int a
ralFromList list = unsafePerformIO $ A.newListArray (0, length list - 1) list
ralLookup i s = unsafePerformIO $ A.readArray s i
ralUpdate i v s = unsafePerformIO $ A.writeArray s i v >> return s
ralToList s = unsafePerformIO $ A.getElems s

#include "../benchs/Ral.inc.hs"
